(*basic calculator.*)
{$a+,B+,D+,E+,F-,G-,I+,L-,N-,O-,P-,Q+,R+,s+,T-,V+,X-}
uses crt;
var
  f     : file;
  table : array['A'..'Z'] of integer;   { }
  sour  : array[0..$0F000] of char;     { }
  ind   : integer;                      {    }
  s, sc : string;                       {   }
  a     : integer;                      { }
  ch    : char;                         {}

procedure get;                          { Upcase -  }
begin
  ch := sour[ind];
  ind:=ind+1;
end;

function basic : integer;  {<-   .}
var
  num : integer;    {  -    }
  c   : char;       {, .    }
  b   : boolean;
begin
  num := 0;         {  }
  get;
  repeat
    b:=false;
    while ch in [#0..#32] do get;  {   .}
    case ch of
     '0'..'9' : begin
                  s := '';          { }
                  repeat
                    s := s + ch;
                    get;
                  until not (ch in ['0'..'9']);
                  val(s, num, a);   {   "s"}
                  b:=true;
                end;
     'A'..'Z' : begin
                  s := '';          { }
                  repeat
                    s := s + ch;
                    get;
                  until not (ch in ['A'..'Z', '0'..'9', '_']);
                  if s = 'IF' then
                  begin
                    num := basic;        { boolean }
                    a := basic;          {    "s"}
                    if num <> 0 then     { boolean=True}
                    begin{       }
                      s := ':' + s;
                      ind := 0;
                      repeat
                        ch := sour[ind];
                        if ch <> ':' then  ind:=ind+1
                        else    { ,   }
                        begin
                          sc := '';
                          repeat
                            sc := sc + ch;
                            ind:=ind+1;
                            ch := sour[ind];
                          until not (ch in ['A'..'Z', '0'..'9', '_']);
                          if s = sc then begin b:=true; break; end; { . }
                        end;
                      until ch = '.';
                      if b=false then
                      begin
                        writeln('Fatal Error: label  <' + s + '> not found');
                        halt;
                      end;
                    end;
                  end
                  {    }
                  else if s = 'WRITE' then  write(basic)   {  }
                  else if s = 'WRITEC' then  write(chr(basic))
                  else if s = 'WRITES' then
                  begin
                    get;
                    while ch <> ';' do {   }
                    begin
                      write(ch);
                      get;
                    end;
                  end
                  else if s = 'READLN' then  {$I-}readln(num){$I+}
                  else if s = 'RAND' then  num := num+random(basic)
                  else if s = 'KEY' then
                  begin
                    if keyPressed then num:=ord(readkey);
                  end
                  else if s = 'FOPEN' then
                  begin
                    s := '';
                    get;
                    while ch <> ';' do
                    begin
                      s := s + ch;
                      get;
                    end;
                    assign(f, s);   {  s  }
                    {$I-}reset(f, 1);{$I+}
                    num := IOresult;
                  end
                  else if s = 'FNEW' then
                  begin
                    s := '';
                    get;
                    while ch <> ';' do
                    begin
                      s := s + ch;
                      get;
                    end;
                    assign(f, s);  {  s  }
                    {$I-}rewrite(f, 1);{$I+}
                    num := IOresult;
                  end
                  else if s = 'FSEEK'  then {$I-}seek(f, basic) {$I+}
                  else if s = 'FSIZE'  then {$I-}num:=integer(fileSize(f)){$I+}
                  else if s = 'FREAD'  then {$I-}blockRead(f, num, 2, a){$I+}
                  else if s = 'FWRITE' then begin num:=basic; {$I-}blockwrite(f, num, 2, a){$I+} end
                  else if s = 'EOF'    then{$I-}num := ord(eof(f)){$I+}
                  else if s = 'FCLOSE' then
                  begin
                    {$I-}close(f);{$I+}
                    num := IOresult;
                  end
                  else
                  begin {    , .      }
                    c := s[1];  num := table[c];
                    {writeln(#9#9#9#9#9'[', c, ']=', num); (*Debugger screen*){}
                  end;
                  b:=true;
                end;
     ':' : begin               {   }
             repeat get; until not (ch in ['a'..'Z', '0'..'9', '_']);
             b:=true;
           end;
     '#' : begin repeat get; until ch=#10; b:=true; end; {    }
     '&' : begin if num = basic  then num := 1 else num := 0;  end;
     '!' : begin if num <> basic then num := 1 else num := 0;  end;
     '<' : begin if num < basic  then num := 1 else num := 0;  end;
     '=' : begin num := basic;  table[c] := num;  end;
     '+' : begin num := num + basic;   end; {. ch }
     '-' : begin num := num - basic;   end; { }
     '*' : begin num := num * basic;   end; {, }
     '/' : begin num := num div basic; end; {  .}
     '(' : begin num := basic; get; b:=true; end;
     ')' : begin end;            {     }
     ';' : begin end;            {    }
     '.' : begin end;            {    }
     else  begin
             {write('Error of chr:',Byte(ch),'="',ch,'"');halt;}
             get;        {  }
             b:=true;
           end;
    end;
  until b=false;
  basic := num;     {  }
  {writeln(#9#9#9#9#9#9#9'= ',  num);  (*Debugger screen*){}
end;

begin
  writeln('basic calculator. v0.0.21'#13#10'OPERATORS: "+", "-", "*", "/",'+
          '"(", ")", ";", ".", "write <ID>;".  ID ="a".."Z"'#13#10'"WRITES '+
          '<string>;". labels- ":MyLabel_1". "IF _ [&,!,<] _; <MyLabel_1>;".');
  { }
  assign(f, paramStr(1));
  reset(f,1);
  blockRead(f,sour,sizeof(sour),ind);
  close(f);
  while (ind>=0) do begin sour[ind]:=upCase(sour[ind]); ind:=ind-1; end;
  {   }
  for ch := 'A' to 'Z' do table[ch] := 0;
  ind := 0;
  repeat
    a := basic;
  until ch = '.';
end.



{
        .
     :
  1.     .
  2.     .
      (    )
-Instruction:---------------------------------------------------------------
        : BS.EXE SOURCE.TXT
       .
        integer, 
  .
:         2-
,     (*Debugger screen*)
            
: 'A'..'Z', 'a'..'z', '0'..'9', '_'.
        ,   
  .  (,  25     "A"  "Z")
   : , , Enter, Esc.
       .
    .
      "#"     .
   ";"          
 
   "." -    , .  .
:        .
   "write"       
 : write <  >.
    -   "writes" -   
   ";"
   "if"      ,  
   .
     :
    IF  _1  [&,!,<]  _2; <>;   (   ":")
-   .
&,!,< -   .  & -    ! -    < - 
   -     .      
- ,        .
   :         
    'A'..'Z', '0'..'9', '_'
   (    )   
.     ":MyLabel_1"
:    ":"    .
-Standart Procedurs and Functions: -----------------------------------------
  "RAND [];" -   .  [0..]
     "Z".
  "KEY;" -    "Z" -   ascII  .
    ,    .
  "FOPEN <FileName>;" -     <FileName>.
    .  <> 0,   
        .  
         .
  "FNEW <FileName>;" -  ,   "OPENFILE",  
 ,      ,   .
  "FSEEK <Pos>;" -    .
:       ,   
    2 ,     
       (..  <Pos>*2)
  "FSIZE;" -    
  "FREAD;"  -           .
  "FWRITE <Num>;" -    a
  "EOF" -      <>0,  
       .
  "FCLOSE;" -      Ms-Dos  .
}